1 package csNd;
2 
3 import java.io.File;
4 import java.io.FileInputStream;
5 import java.io.FileOutputStream;
6 import java.nio.channels.FileChannel;
7 
8 public class CapMerger {
9 public static final long globheader=24; //numero di byte del globalheader del .cap inputhPath1
10
11
12	public CapMerger() {
13		
14	}
15	
16	//funziona per globalheader .cap di 24 byte
17	//ad ogni nuovo file aggiunto vengono rimossi questi byte per non corrompere il file .cap
18	// consultare "https://wiki.wireshark.org/Development/LibpcapFileFormat" per informazioni
19	
20	//se append  settato a false creail file o lo sovrascrive,
21	//altrimenti appende il cap contenuto in inputpath uno al cap presente in outputhpath
22	public static void MergeToOUT(String inputPath1, String OutputPath, boolean append) {
23		
24		File in1=new File(inputPath1);
25		File out=new File(OutputPath);
26		FileOutputStream fOut;
27		FileInputStream fin1;
28		
29		try {
30			fin1 = new FileInputStream(in1);
31			if (append) {
32				fin1.getChannel().position(globheader);//scarta i primi 24 byte(header)
33			}
34			
35	    	fOut = new FileOutputStream(out,append);
36	    	FileChannel sourceChannel1 = fin1.getChannel();
37	    	FileChannel destChannel = fOut.getChannel();
38	        destChannel.transferFrom(sourceChannel1, destChannel.size(), sourceChannel1.size());
39	        sourceChannel1.close();
40	        destChannel.close();
41	        fin1.close();
42	        fOut.close();
43		}catch(Exception e) {
44			
45		}
46	}
47	
48}
49