1  package csNd;
2  
3  import java.io.File;
4  import java.io.FileOutputStream;
5  import java.io.IOException;
6  import java.io.OutputStream;
7  
8  import org.apache.commons.net.ftp.FTP;
9  import org.apache.commons.net.ftp.FTPSClient;
10 
11 
12 public class Dumper {
13 	
14 	// campi 
15 	
16 	public String hostFTP;
17 	public String usr;
18 	public String psw;
19 	public int Port;
20 	//public FTPClient ftpClient;
21 	public FTPSClient ftps;
22 	public String protocol = "TLS";
23 		
24 	//costruttori
25 	 
26 	public Dumper(String host,String user, String password,int PORT) {
27 		this.hostFTP=host;
28 		this.usr=user;
29 		this.psw=password;
30 		this.Port=PORT;
31 	}
32 	
33 	//metodi
34 	
35 	public synchronized static boolean CheckFTP(String server,String usr,String inskey,int port) {
36 		//FTPClient ftpClient = new FTPClient();
37 		FTPSClient ftps = new FTPSClient();
38 		boolean res=false;
39 		try {
40 			ftps.connect(server);
41             res= ftps.login(usr, inskey);   
42             }catch(Exception e){
43 			return false;
44 		}
45 		try {
46             if (ftps.isConnected()) {
47                 ftps.logout();
48                 ftps.disconnect();
49             }
50         } catch (IOException ex) {
51             ex.printStackTrace();
52             return false;
53         }
54 		return res;
55 		
56 	}
57 	
58 	// metodo per il salvataggio da server su cartella locale
59 	public boolean saveLocalFile(String FTPdir,String RemoteName, String localOutputPath) {
60 		
61 		ftps=new FTPSClient(protocol);
62         try {
63             ftps.connect(this.hostFTP, this.Port);
64             ftps.login(this.usr, this.psw);
65             ftps.enterLocalPassiveMode();
66             ftps.setFileType(FTP.BINARY_FILE_TYPE);
67             //testa esistenza cartella specificata in CONFIG.ini)
68             ftps.changeWorkingDirectory(FTPdir);
69             int returnCodeA = ftps.getReplyCode();
70             if (returnCodeA == 550) {//se la directory specificata 
71             	return false;            
72             }        
73             File LocalFile = new File(localOutputPath); 
74             OutputStream outputStream = new FileOutputStream(LocalFile);    
75             //System.out.println("\n### Inizio download file: \n"+FTPdir+"/"+RemoteFile+" ###");
76             boolean done = ftps.retrieveFile(RemoteName, outputStream);   
77             outputStream.close();
78             return done;
79             
80         } catch (IOException ex) {
81              return false;
82         } finally {
83             try {
84                 if (ftps.isConnected()) {
85                     ftps.logout();
86                     ftps.disconnect();
87                 }
88             } catch (IOException ex) {
89                 
90             }
91         }		
92      
93 	}
94 	//metodo che ritorna un array contenente i file rilevati nella directory FTPdir
95 	public String[] GetRemoteFiles(String FTPdir){
96 		String [] alldumps;
97 		ftps=new FTPSClient(protocol);
98         try {
99             ftps.connect(this.hostFTP, this.Port);
100            ftps.login(this.usr, this.psw);
101            ftps.enterLocalPassiveMode();
102            ftps.setFileType(FTP.BINARY_FILE_TYPE);
103            //testa esistenza cartella specificata in CONFIG.ini)
104            ftps.changeWorkingDirectory(FTPdir);
105            int returnCodeA = ftps.getReplyCode();
106            if (returnCodeA == 550) {//se la directory specificata in ini non esiste
107            	return null;            
108            }        
109            alldumps = ftps.listNames(FTPdir);
110            
111            return alldumps;
112        } catch (IOException ex) {
113             return null;
114        } finally {
115            try {
116                if (ftps.isConnected()) {
117                    ftps.logout();
118                    ftps.disconnect();
119                }
120            } catch (IOException ex) {
121                return null;
122            }
123        }		
124	}	
125}
126