1   package csNa_GUI;
2   
3   import java.awt.EventQueue;
4   
5   import javax.swing.JFrame;
6   import javax.swing.JTextArea;
7   import javax.swing.JLabel;
8   import javax.swing.JOptionPane;
9   import javax.swing.SwingConstants;
10  import javax.swing.JButton;
11  import java.awt.Color;
12  import java.awt.SystemColor;
13  import javax.swing.JTextField;
14  import javax.swing.JScrollPane;
15  import java.awt.event.ActionListener;
16  import java.io.File;
17  import java.io.FileReader;
18  import java.text.DateFormat;
19  import java.text.SimpleDateFormat;
20  import java.awt.event.ActionEvent;
21  import java.awt.Font;
22  import javax.swing.JSpinner;
23  
24  import org.ini4j.Ini;
25  import org.ini4j.Wini;
26  import org.jnetpcap.Pcap;
27  import org.jnetpcap.packet.JPacket;
28  import org.jnetpcap.packet.JPacketHandler;
29  import org.jnetpcap.packet.PcapPacket;
30  import org.jnetpcap.packet.format.FormatUtils;
31  import org.jnetpcap.protocol.network.Ip4;
32  import org.jnetpcap.protocol.tcpip.Tcp;
33  import org.jnetpcap.protocol.tcpip.Udp;
34  
35  import csNd.CapMerger;
36  import csNd.CaptureCycle;
37  import csNd.Dumper;
38  
39  
40  import javax.swing.JRadioButton;
41  import javax.swing.JSeparator;
42  import javax.swing.SpinnerNumberModel;
43  import javax.swing.Box;
44  import javax.swing.border.MatteBorder;
45  import javax.swing.SpinnerDateModel;
46  import javax.swing.JCheckBox;
47  import java.util.Date;
48  import java.util.StringTokenizer;
49  import java.util.Vector;
50  import java.util.Calendar;
51  import javax.swing.event.ChangeListener;
52  import javax.swing.event.ChangeEvent;
53  import javax.swing.border.LineBorder;
54  import javax.swing.UIManager;
55  
56  
57  
58  public class csNa_GUI {
59  
60  	private JFrame frmCsnaBy;
61  	private JTextArea ConsoleFTP;
62  	private JTextField KEY;
63  	private JTextField HOST;
64  	private JTextField USER;
65  	private JTextField DIR;
66  	private JTextField EXPR_FILTER;
67  	private JTextField ExportUserPath;
68  
69  	/**
70  	 * Launch the application.
71  	 */
72  	public static void main(String[] args) {
73  		EventQueue.invokeLater(new Runnable() {
74  			public void run() {
75  				try {
76  					csNa_GUI window = new csNa_GUI();
77  					window.frmCsnaBy.setVisible(true);
78  				} catch (Exception e) {
79  					e.printStackTrace();
80  				}
81  			}
82  		});
83  	}
84  
85  	/**
86  	 * Create the application.
87  	 */
88  	public csNa_GUI() {
89  		initialize();
90  	}
91  
92  	/**
93  	 * Initialize the contents of the frame.
94  	 */
95  	private void initialize() {
96  		frmCsnaBy = new JFrame();
97  		frmCsnaBy.setFont(new Font("Dialog", Font.BOLD, 21));
98  		frmCsnaBy.setBackground(Color.WHITE);
99  		frmCsnaBy.setTitle("DMAD - Download, Merge, Analyze and Dump - by Alessio");
100 		frmCsnaBy.getContentPane().setBackground(SystemColor.activeCaption);
101 		frmCsnaBy.setBounds(100, 100, 1298, 707);
102 		frmCsnaBy.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
103 		frmCsnaBy.getContentPane().setLayout(null);
104 		
105 		JLabel lblPort = new JLabel("Port");
106 		lblPort.setBounds(7, 15, 51, 20);
107 		lblPort.setFont(new Font("SansSerif", Font.PLAIN, 15));
108 		lblPort.setBackground(Color.LIGHT_GRAY);
109 		lblPort.setHorizontalAlignment(SwingConstants.CENTER);
110 		frmCsnaBy.getContentPane().add(lblPort);
111 		
112 		JLabel lblFtpHost = new JLabel("Host");
113 		lblFtpHost.setBounds(7, 60, 51, 20);
114 		lblFtpHost.setFont(new Font("SansSerif", Font.PLAIN, 15));
115 		lblFtpHost.setHorizontalAlignment(SwingConstants.CENTER);
116 		frmCsnaBy.getContentPane().add(lblFtpHost);
117 		
118 		JLabel lblKey = new JLabel("Key");
119 		lblKey.setBounds(134, 15, 34, 20);
120 		lblKey.setFont(new Font("SansSerif", Font.PLAIN, 15));
121 		lblKey.setHorizontalAlignment(SwingConstants.CENTER);
122 		frmCsnaBy.getContentPane().add(lblKey);
123 		
124 		JLabel lblUtilizzaI = new JLabel("-> Utilizza i Dump filtrati ");
125 		lblUtilizzaI.setForeground(UIManager.getColor("Button.light"));
126 		lblUtilizzaI.setFont(new Font("Tahoma", Font.PLAIN, 16));
127 		lblUtilizzaI.setHorizontalAlignment(SwingConstants.CENTER);
128 		lblUtilizzaI.setBounds(1062, 197, 210, 20);
129 		frmCsnaBy.getContentPane().add(lblUtilizzaI);
130 		
131 		JLabel lblDir = new JLabel("User");
132 		lblDir.setBounds(7, 103, 51, 20);
133 		lblDir.setFont(new Font("SansSerif", Font.PLAIN, 15));
134 		lblDir.setHorizontalAlignment(SwingConstants.CENTER);
135 		frmCsnaBy.getContentPane().add(lblDir);
136 		
137 		JLabel lblFtpsLog = new JLabel("MODULO FTPS");
138 		lblFtpsLog.setBounds(400, 192, 144, 22);
139 		lblFtpsLog.setFont(new Font("Tahoma", Font.BOLD, 16));
140 		lblFtpsLog.setHorizontalAlignment(SwingConstants.CENTER);
141 		frmCsnaBy.getContentPane().add(lblFtpsLog);
142 		
143 		JLabel lblMainConsole = new JLabel("DMAD - Console");
144 		lblMainConsole.setBackground(new Color(230, 230, 250));
145 		lblMainConsole.setBounds(154, 281, 253, 38);
146 		lblMainConsole.setHorizontalAlignment(SwingConstants.CENTER);
147 		lblMainConsole.setFont(new Font("Tahoma", Font.PLAIN, 30));
148 		frmCsnaBy.getContentPane().add(lblMainConsole);
149 		
150 		ExportUserPath = new JTextField();
151 		ExportUserPath.setBackground(new Color(255, 245, 238));
152 		ExportUserPath.setHorizontalAlignment(SwingConstants.CENTER);
153 		ExportUserPath.setFont(new Font("Tahoma", Font.PLAIN, 14));
154 		ExportUserPath.setText("DMAD_Export_Utente");
155 		ExportUserPath.setBounds(1002, 241, 228, 26);
156 		frmCsnaBy.getContentPane().add(ExportUserPath);
157 		ExportUserPath.setColumns(10);
158 		
159 		JLabel exportMSG = new JLabel("Salva come: \\Export\\Export_Pt0_");
160 		exportMSG.setHorizontalAlignment(SwingConstants.CENTER);
161 		exportMSG.setBounds(699, 238, 303, 32);
162 		exportMSG.setFont(new Font("Tahoma", Font.PLAIN, 18));
163 		frmCsnaBy.getContentPane().add(exportMSG);
164 		
165 		JSpinner portFilter = new JSpinner();
166 		portFilter.addChangeListener(new ChangeListener() {
167 			public void stateChanged(ChangeEvent arg0) {
168 				exportMSG.setText("Salva come: \\Export\\Export_Pt"+(Integer)portFilter.getValue()+"_");
169 				}
170 		});
171 		portFilter.setBounds(735, 112, 90, 32);
172 		portFilter.setFont(new Font("Tahoma", Font.PLAIN, 18));
173 		portFilter.setModel(new SpinnerNumberModel(1, 1, 65535, 1));
174 		frmCsnaBy.getContentPane().add(portFilter);
175 		
176 		JRadioButton EXPR_FLAG = new JRadioButton("Filtro Payload");
177 		EXPR_FLAG.setBounds(656, 156, 152, 25);
178 		EXPR_FLAG.addActionListener(new ActionListener() {
179 			public void actionPerformed(ActionEvent arg0) {
180 				if(EXPR_FLAG.isSelected()) {
181 					EXPR_FILTER.setEnabled(true);
182 				}else {
183 					EXPR_FILTER.setEnabled(false);
184 				}
185 			}
186 		});
187 		
188 		JCheckBox FTP_DELETE_FLAG = new JCheckBox("/Files_FTP");
189 		FTP_DELETE_FLAG.setHorizontalAlignment(SwingConstants.CENTER);
190 		FTP_DELETE_FLAG.setFont(new Font("Tahoma", Font.PLAIN, 18));
191 		FTP_DELETE_FLAG.setBackground(SystemColor.activeCaption);
192 		FTP_DELETE_FLAG.setBounds(665, 10, 159, 29);
193 		frmCsnaBy.getContentPane().add(FTP_DELETE_FLAG);
194 		
195 		JRadioButton PORT_YN = new JRadioButton("Porta");
196 		PORT_YN.addActionListener(new ActionListener() {
197 			public void actionPerformed(ActionEvent arg0) {
198 				if(PORT_YN.isSelected()) {
199 					portFilter.setEnabled(true);
200 				}else {
201 					portFilter.setEnabled(false);
202 				}
203 			}
204 		});
205 		
206 		PORT_YN.setSelected(true);
207 		PORT_YN.setFont(new Font("SansSerif", Font.PLAIN, 18));
208 		PORT_YN.setBackground(SystemColor.activeCaption);
209 		PORT_YN.setBounds(656, 114, 77, 29);
210 		frmCsnaBy.getContentPane().add(PORT_YN);
211 		
212 		JCheckBox USER_DELETE_FLAG = new JCheckBox("/Files_Utente");
213 		USER_DELETE_FLAG.setHorizontalAlignment(SwingConstants.CENTER);
214 		USER_DELETE_FLAG.setFont(new Font("Tahoma", Font.PLAIN, 18));
215 		USER_DELETE_FLAG.setBackground(SystemColor.activeCaption);
216 		USER_DELETE_FLAG.setBounds(665, 40, 181, 29);
217 		frmCsnaBy.getContentPane().add(USER_DELETE_FLAG);
218 		
219 		JCheckBox EXPORT_DELETE_FLAG = new JCheckBox("/Export");
220 		EXPORT_DELETE_FLAG.setHorizontalAlignment(SwingConstants.CENTER);
221 		EXPORT_DELETE_FLAG.setFont(new Font("Tahoma", Font.PLAIN, 18));
222 		EXPORT_DELETE_FLAG.setBackground(SystemColor.activeCaption);
223 		EXPORT_DELETE_FLAG.setBounds(831, 5, 144, 64);
224 		frmCsnaBy.getContentPane().add(EXPORT_DELETE_FLAG);
225 		EXPR_FLAG.setBackground(SystemColor.activeCaption);
226 		EXPR_FLAG.setFont(new Font("SansSerif", Font.PLAIN, 18));
227 		frmCsnaBy.getContentPane().add(EXPR_FLAG);
228 		
229 		JRadioButton FLOW_CONTR_FLAG = new JRadioButton("Flow Control TCP");
230 		FLOW_CONTR_FLAG.setBounds(656, 195, 181, 25);
231 		FLOW_CONTR_FLAG.setBackground(SystemColor.activeCaption);
232 		FLOW_CONTR_FLAG.setFont(new Font("SansSerif", Font.PLAIN, 18));
233 		frmCsnaBy.getContentPane().add(FLOW_CONTR_FLAG);
234 		
235 		JRadioButton DEEP_SCAN_FLAG = new JRadioButton("Scansione approfondita");
236 		DEEP_SCAN_FLAG.addActionListener(new ActionListener() {
237 			public void actionPerformed(ActionEvent arg0) {
238 				if (DEEP_SCAN_FLAG.isSelected()) {
239 					lblUtilizzaI.setText("-> Utilizza i Dump \"NOfilter\"");
240 					lblUtilizzaI.setForeground(Color.black);
241 				}
242 				else {
243 					lblUtilizzaI.setText("-> Utilizza i Dump filtrati");
244 					lblUtilizzaI.setForeground(UIManager.getColor("Button.light"));
245 				}
246 					
247 					
248 			}
249 		});
250 		DEEP_SCAN_FLAG.setBounds(840, 195, 225, 24);
251 		DEEP_SCAN_FLAG.setBackground(SystemColor.activeCaption);
252 		DEEP_SCAN_FLAG.setFont(new Font("SansSerif", Font.PLAIN, 18));
253 		frmCsnaBy.getContentPane().add(DEEP_SCAN_FLAG);
254 		
255 		JSpinner PORTFTP = new JSpinner();
256 		PORTFTP.setModel(new SpinnerNumberModel(1, 1, 65535, 1));
257 		PORTFTP.setBounds(66, 7, 64, 34);
258 		PORTFTP.setFont(new Font("Tahoma", Font.PLAIN, 16));
259 		frmCsnaBy.getContentPane().add(PORTFTP);
260 		
261 		JScrollPane scrollPane_1 = new JScrollPane();
262 		scrollPane_1.setBounds(7, 329, 1266, 318);
263 		frmCsnaBy.getContentPane().add(scrollPane_1);
264 		
265 		JTextArea csNaLOG = new JTextArea();
266 		csNaLOG.setEditable(false);
267 		scrollPane_1.setViewportView(csNaLOG);
268 		
269 		JButton Check = new JButton("Connetti al server");
270 		Check.setBounds(7, 187, 181, 33);
271 		Check.addActionListener(new ActionListener() {			
272 			public void actionPerformed(ActionEvent arg0) {				
273 				ConsoleFTP.append("\n>> Lettura dati\n");
274 				Check.setEnabled(false);
275 				String host=HOST.getText();
276 				String user=USER.getText();
277 				String key=KEY.getText();
278 				String FTPdir=DIR.getText();
279 				int portftp=21;	
280 				try {
281 					portftp=((Integer)PORTFTP.getValue());
282 				}catch(Exception e) {
283 					PORTFTP.setValue(Integer.valueOf(21));
284 					ConsoleFTP.setText(ConsoleFTP.getText()+"\n>> La porta deve essere un numero!");
285 				}
286 				ConsoleFTP.append("\n>> Connessione in corso...");
287 				ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length()-1);
288 				final int p=portftp;
289 				new Thread(new Runnable() {
290 				    public void run() {
291 				        //apro un thread per non bloccare il messaggio iniziale
292 				boolean check=false; 
293 				Dumper dumper;
294 				String []file=null;
295 				try {
296 					dumper=new Dumper(host, user, key, p);
297 					check=Dumper.CheckFTP(host, user, key, p);
298 					file=dumper.GetRemoteFiles("/"+FTPdir);
299 					Check.setEnabled(true);
300 				}catch (Exception e) {
301 					ConsoleFTP.setText(ConsoleFTP.getText()+"\n>> Connessione fallita.\n");
302 					ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
303 					csNaLOG.append("\n>> Connessione fallita.\n");
304 					csNaLOG.setSelectionStart(csNaLOG.getText().length());
305 					Check.setEnabled(true);
306 				}
307 				Check.setEnabled(true);
308 				StringTokenizer tokenizer;
309 				
310 				if(check) {
311 					ConsoleFTP.append("\n>> Porta ftp: "+((Integer)PORTFTP.getValue()).toString());
312 					ConsoleFTP.setText(ConsoleFTP.getText()+"\n>> "+user+"\n>> Connessione riuscita.\n");
313 					csNaLOG.append("\n>> Lettura files nella cartella: "+FTPdir+"\n");
314 					csNaLOG.setSelectionStart(csNaLOG.getText().length());
315 					ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
316 				}
317 				else {
318 					ConsoleFTP.setText(ConsoleFTP.getText()+"\n>> Connessione fallita.\n");
319 					ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
320 					csNaLOG.append("\n>> Connessione fallita.\n");
321 					csNaLOG.setSelectionStart(csNaLOG.getText().length());
322 					JOptionPane.showMessageDialog(frmCsnaBy, "Errore nella connessione a: "+HOST.getText());
323 				}
324 				for (String s:file) {
325 					tokenizer=new StringTokenizer(s, "-");
326 					String token=tokenizer.nextToken();
327 					if(token.equals("NOfilter")) {
328 						csNaLOG.append("\n -> "+s+": rilevato DUMP non filtrato");
329 					}else if(token.equals("Port")) {
330 						csNaLOG.append("\n -> "+s+": rilevato DUMP filtrato");
331 					}
332 					
333 					else {
334 						csNaLOG.append("\n\n   # "+s+" : File generico/directory -> non verr scaricato da DMAD");
335 					}
336 				}
337 				ConsoleFTP.append("\n\n>> FINE, DMAD pronto:");
338 				ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
339 				csNaLOG.setSelectionStart(csNaLOG.getText().length());
340 				
341 				    }
342 				}).start();	
343 				
344 			}
345 		});
346 		
347 		
348 		csNaLOG.setFont(new Font("Monospaced", Font.PLAIN, 12));
349 		csNaLOG.setTabSize(12);
350 		csNaLOG.setText("DMAD pronto:\r\n>>");
351 		csNaLOG.setBackground(new Color(255, 255, 255));
352 		Check.setFont(new Font("SansSerif", Font.BOLD, 16));
353 		Check.setBackground(new Color(240, 255, 255));
354 		frmCsnaBy.getContentPane().add(Check);
355 		
356 		KEY = new JTextField();
357 		KEY.setHorizontalAlignment(SwingConstants.CENTER);
358 		KEY.setBounds(172, 9, 144, 32);
359 		KEY.setFont(new Font("SansSerif", Font.PLAIN, 15));
360 		frmCsnaBy.getContentPane().add(KEY);
361 		
362 		JScrollPane scrollPane = new JScrollPane();
363 		scrollPane.setBounds(325, 9, 313, 173);
364 		frmCsnaBy.getContentPane().add(scrollPane);
365 		
366 		ConsoleFTP = new JTextArea();
367 		ConsoleFTP.setBackground(new Color(255, 255, 240));
368 		scrollPane.setViewportView(ConsoleFTP);
369 		ConsoleFTP.setFont(new Font("SansSerif", Font.PLAIN, 13));
370 		ConsoleFTP.setText("DMAD PRONTO:\r\n>>");
371 		ConsoleFTP.setEditable(false);
372 		ConsoleFTP.setColumns(10);
373 		
374 		HOST = new JTextField();
375 		HOST.setHorizontalAlignment(SwingConstants.CENTER);
376 		HOST.setBounds(66, 54, 250, 32);
377 		HOST.setFont(new Font("SansSerif", Font.PLAIN, 15));
378 		frmCsnaBy.getContentPane().add(HOST);
379 		HOST.setColumns(10);
380 		
381 		USER = new JTextField();
382 		USER.setHorizontalAlignment(SwingConstants.CENTER);
383 		USER.setBounds(66, 98, 250, 32);
384 		USER.setFont(new Font("SansSerif", Font.PLAIN, 15));
385 		USER.setColumns(10);
386 		frmCsnaBy.getContentPane().add(USER);
387 		
388 		DIR = new JTextField();
389 		DIR.setHorizontalAlignment(SwingConstants.CENTER);
390 		DIR.setBounds(66, 142, 250, 32);
391 		DIR.setFont(new Font("SansSerif", Font.PLAIN, 15));
392 		DIR.setColumns(10);
393 		frmCsnaBy.getContentPane().add(DIR);
394 		
395 		Box horizontalBox_1 = Box.createHorizontalBox();
396 		horizontalBox_1.setBounds(400, 189, 144, 28);
397 		horizontalBox_1.setBackground(SystemColor.inactiveCaption);
398 		horizontalBox_1.setBorder(new MatteBorder(1, 1, 1, 1, (Color) SystemColor.menuText));
399 		frmCsnaBy.getContentPane().add(horizontalBox_1);
400 		
401 		JLabel label = new JLabel("DIR");
402 		label.setBounds(7, 148, 51, 20);
403 		label.setFont(new Font("SansSerif", Font.PLAIN, 15));
404 		label.setHorizontalAlignment(SwingConstants.CENTER);
405 		frmCsnaBy.getContentPane().add(label);
406 		
407 		JButton CLC = new JButton("CLC");
408 		CLC.setBounds(7, 281, 129, 38);
409 		CLC.addActionListener(new ActionListener() {
410 			public void actionPerformed(ActionEvent arg0) {
411 				
412 				ConsoleFTP.setText("DMAD PRONTO \n>>" );
413 				csNaLOG.setText("DMAD pronto:\n>>\n");
414 								
415 			}
416 		});
417 		CLC.setFont(new Font("SansSerif", Font.BOLD, 18));
418 		CLC.setBackground(SystemColor.inactiveCaption);
419 		frmCsnaBy.getContentPane().add(CLC);
420 		
421 		JSeparator separator_1 = new JSeparator();
422 		separator_1.setBounds(646, 7, 2, 220);
423 		separator_1.setOrientation(SwingConstants.VERTICAL);
424 		separator_1.setBackground(SystemColor.controlHighlight);
425 		frmCsnaBy.getContentPane().add(separator_1);
426 		
427 		EXPR_FILTER = new JTextField();
428 		EXPR_FILTER.setText(".*[a-zA-Z0-9._%-]+[0-9].*");
429 		EXPR_FILTER.setFont(new Font("Tahoma", Font.PLAIN, 17));
430 		EXPR_FILTER.setBounds(807, 154, 454, 32);
431 		EXPR_FILTER.setEnabled(false);
432 		EXPR_FILTER.setHorizontalAlignment(SwingConstants.CENTER);
433 		frmCsnaBy.getContentPane().add(EXPR_FILTER);
434 		EXPR_FILTER.setColumns(10);
435 		
436 		JSeparator separator = new JSeparator();
437 		separator.setBounds(7, 226, 1278, 2);
438 		separator.setBackground(SystemColor.control);
439 		frmCsnaBy.getContentPane().add(separator);
440 		
441 		JSpinner Data_FINE = new JSpinner();
442 		Data_FINE.setBounds(1112, 112, 149, 32);
443 		Data_FINE.setFont(new Font("SansSerif", Font.PLAIN, 18));
444 		Data_FINE.setModel(new SpinnerDateModel(new Date(1520463600000L), null, null, Calendar.WEEK_OF_YEAR));
445 		frmCsnaBy.getContentPane().add(Data_FINE);
446 		
447 		JSpinner Data_INIZIO = new JSpinner();
448 		Data_INIZIO.setBounds(938, 112, 149, 32);
449 		Data_INIZIO.setModel(new SpinnerDateModel(new Date(1520463600000L), null, null, Calendar.DAY_OF_MONTH));
450 		Data_INIZIO.setFont(new Font("SansSerif", Font.PLAIN, 18));
451 		frmCsnaBy.getContentPane().add(Data_INIZIO);
452 		
453 		JButton SaveIni = new JButton("Salva impostazioni");
454 		SaveIni.setBounds(198, 235, 181, 35);
455 		SaveIni.addActionListener(new ActionListener() {
456 			public void actionPerformed(ActionEvent arg0) {
457 				Wini ini;
458 				boolean cond=HOST.getText().equals("")||USER.getText().equals("");
459 				if(!cond) {
460 					try {
461 						ConsoleFTP.append("\n>> Salvataggio delle impostazioni...");
462 						ini=new Wini(new File("CONFIG.ini"));
463 						ini.put("FTP_LOGIN", "PathFTP",DIR.getText());
464 						ini.put("SPLIT_OPTION","EXPRESSION_FILTER",EXPR_FILTER.getText());
465 						ini.put("FTP_LOGIN", "HostFTP",HOST.getText());
466 						ini.put("FTP_LOGIN", "UsrFTP",USER.getText());
467 						if(!KEY.getText().equals("")) {
468 							int YN=JOptionPane.showConfirmDialog(frmCsnaBy, "Vuoi salvare la Password del Server ftp specificata? (Opzione sconsigliata)","Conferma salvataggio password",JOptionPane.YES_NO_OPTION);
469 							if(YN==JOptionPane.YES_OPTION) {
470 								ini.put("FTP_LOGIN", "KeyFTP",KEY.getText());
471 								ConsoleFTP.append("\n  Chiave ftp -> CONFIG.ini\n");
472 							}else {
473 								ini.put("FTP_LOGIN", "KeyFTP","");
474 								ConsoleFTP.append("\n >> Chiave non salvata ;)\n");
475 							}
476 						}else {
477 							ini.put("FTP_LOGIN", "KeyFTP",KEY.getText());
478 							ConsoleFTP.append("\n >> Chiave ftp resettata.\n");
479 						}
480 						String datemin = new SimpleDateFormat("yyyy_MM_dd_HH_mm_ss").format(Data_INIZIO.getValue());
481 						String datemax = new SimpleDateFormat("yyyy_MM_dd_HH_mm_ss").format(Data_FINE.getValue());
482 						ini.put("SPLIT_OPTION", "Date_min",datemin);
483 						ini.put("SPLIT_OPTION", "Date_max",datemax);
484 						//ini.put("FTP_LOGIN", "KeyFTP",KEY.getText());
485 						ini.put("FTP_LOGIN", "PortFTP",(Integer)PORTFTP.getValue());
486 						ini.put("SPLIT_OPTION","Port",(Integer)portFilter.getValue());
487 						
488 						ini.store();
489 						ConsoleFTP.append("\n>> Impostazioni salvate!");
490 						ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
491 						csNaLOG.setSelectionStart(csNaLOG.getText().length());
492 					}catch(Exception e) {
493 						ConsoleFTP.append("\n>> Errore nel salvataggio delle impostazioni!");
494 						ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
495 					}
496 				}else {
497 					ConsoleFTP.append("\n>> Impossibile salvare: campi HOST e USER vuoti.");
498 					ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
499 				}
500 				
501 				
502 			}
503 		});
504 		SaveIni.setFont(new Font("SansSerif", Font.PLAIN, 13));
505 		SaveIni.setBackground(new Color(169, 169, 169));
506 		frmCsnaBy.getContentPane().add(SaveIni);
507 		
508 		JButton LoadIni = new JButton("Carica impostazioni");
509 		LoadIni.setBounds(7, 235, 181, 35);
510 		LoadIni.addActionListener(new ActionListener() {
511 			public void actionPerformed(ActionEvent e) {
512 				Ini inifile=new Ini();
513 				DateFormat parser = new SimpleDateFormat ("yyyy_MM_dd_HH_mm_ss");
514 				try {			
515 					Ini conFile = new Ini(new FileReader("CONFIG.ini"));
516 					inifile=conFile;
517 				}catch(Exception ex) {
518 					ConsoleFTP.append("\n>> Errore nel caricamento delle impostazioni :(\n");
519 				}
520 				DIR.setText(inifile.get("FTP_LOGIN", "PathFTP"));
521 				HOST.setText(inifile.get("FTP_LOGIN", "HostFTP"));
522 				USER.setText(inifile.get("FTP_LOGIN", "UsrFTP"));
523 				EXPR_FILTER.setText(inifile.get("SPLIT_OPTION","EXPRESSION_FILTER"));
524 				String k=inifile.get("FTP_LOGIN","KeyFTP");
525 				if(k.equals("")) {
526 					ConsoleFTP.append("\n >> Chiave ftp non rilevata nel file CONFIG.ini\n");
527 				}else {
528 					KEY.setText(k);
529 					ConsoleFTP.append("\n >> Password FTP rilevata: "+k+" \n\n >> E' sconsigliato salvare la password \n");	
530 				}
531 				try {
532 					Data_INIZIO.setValue(parser.parse(inifile.get("SPLIT_OPTION", "Date_min")));
533 					Data_FINE.setValue(parser.parse(inifile.get("SPLIT_OPTION", "Date_max")));
534 				}catch(Exception exc) {}
535 				
536 				//KEY.setText(inifile.get("FTP_LOGIN", "KeyFTP"));
537 				PORTFTP.setValue(Integer.valueOf(inifile.get("FTP_LOGIN", "PortFTP")));
538 				portFilter.setValue(Integer.valueOf(inifile.get("SPLIT_OPTION", "Port")));
539 				ConsoleFTP.append("\n>> Impostazioni caricate!");
540 				ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
541 								
542 			}
543 		});
544 		LoadIni.setFont(new Font("SansSerif", Font.PLAIN, 13));
545 		LoadIni.setBackground(new Color(169, 169, 169));
546 		frmCsnaBy.getContentPane().add(LoadIni);
547 				
548 		
549 		JLabel lblInizio = new JLabel("Intervallo");
550 		lblInizio.setBounds(829, 112, 104, 32);
551 		lblInizio.setHorizontalAlignment(SwingConstants.CENTER);
552 		lblInizio.setFont(new Font("Tahoma", Font.BOLD, 18));
553 		frmCsnaBy.getContentPane().add(lblInizio);
554 		
555 		JLabel lblFine = new JLabel("-");
556 		lblFine.setBounds(1088, 112, 22, 32);
557 		lblFine.setHorizontalAlignment(SwingConstants.CENTER);
558 		lblFine.setFont(new Font("SansSerif", Font.BOLD, 18));
559 		frmCsnaBy.getContentPane().add(lblFine);
560 		
561 		JButton DownloadDump = new JButton("Scarica File");
562 		DownloadDump.setBounds(198, 187, 181, 33);
563 		DownloadDump.addActionListener(new ActionListener() {
564 			public void actionPerformed(ActionEvent arg0) {
565 				DownloadDump.setEnabled(false);
566 				ConsoleFTP.setText(ConsoleFTP.getText()+"\n\n>> Connessione in corso...");
567 				ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
568 				String host=HOST.getText();
569 				String user=USER.getText();
570 				String key=KEY.getText();
571 				String FTPdir=DIR.getText();
572 				int portftp=21;	
573 				try {
574 					portftp=((Integer)PORTFTP.getValue());
575 				}catch(Exception e) {
576 					PORTFTP.setValue(Integer.valueOf(21));
577 					ConsoleFTP.setText(ConsoleFTP.getText()+"\n>> La porta deve essere un numero!");
578 					ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
579 				}final int p=portftp;
580 				new Thread(new Runnable() {
581 				    public void run() {
582 				        //apro un thread per non bloccare il messaggio iniziale
583 				Dumper dumper=new Dumper(host, user, key, p);
584 				boolean check=Dumper.CheckFTP(host, user, key, p);
585 				String[] file=dumper.GetRemoteFiles("/"+FTPdir);
586 				//ottengo i nomi di tutti i file contenuti della cartella
587 				StringTokenizer tokenizer;
588 				
589 				if(check) {
590 					ConsoleFTP.append("\n>> Connessione riuscita\n>> Porta ftp: "+((Integer)PORTFTP.getValue()).toString());
591 					ConsoleFTP.setText(ConsoleFTP.getText()+"\n>> "+user+": Inizio download file...\n");
592 					csNaLOG.append("\n\n>> Lettura files nella cartella: "+FTPdir+"\n");
593 					csNaLOG.setSelectionStart(csNaLOG.getText().length());
594 					ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
595 				}
596 				else {
597 					ConsoleFTP.setText(ConsoleFTP.getText()+"\n>> Connessione fallita.\n");
598 					csNaLOG.append("\n>> Connessione fallita.\n");
599 					DownloadDump.setEnabled(true);
600 				}
601 				ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
602 				//ora cerco i file voluti
603 				int cont=0;
604 				for (String s:file) {
605 					cont++;
606 					if(cont>=file.length)
607 					{
608 						DownloadDump.setEnabled(true);
609 					}
610 					tokenizer=new StringTokenizer(s, "-");
611 					String type=tokenizer.nextToken();
612 					//inizializzo variabili per il confronto della data del file con 
613 					//l'intervallo del filtro
614 					DateFormat df = new SimpleDateFormat ("yyyy_MM_dd.HH_mm");
615 					df.setLenient (false);
616 					Date inizio=(Date)Data_INIZIO.getValue();
617 					df.format(inizio);
618 					Date fine=(Date)Data_FINE.getValue();
619 					df.format(fine);
620 					// Ora posso iniziare a distinguere se file filtrato per porta o non filtrato
621 					if(type.equals("NOfilter")) {
622 						tokenizer.nextToken();
623 						String fileDate="";
624 						// ricavo la data del dump e cancello l'estensione .cap
625 						fileDate=tokenizer.nextToken();
626 						//csNaLOG.append(fileDate);
627 						fileDate=fileDate.substring(0,(fileDate.length()-4));
628 						//csNaLOG.append("->"+fileDate);
629 						Date d=new Date();
630 						try {
631 							d = df.parse (fileDate);
632 						}catch(Exception e) {
633 							csNaLOG.append("\nErrore nella lettura dell'intervallo selezionato! :( \n");
634 							ConsoleFTP.setText("\n>> Errore lettura intervallo");
635 							DownloadDump.setEnabled(true);
636 							
637 						}						
638 						//csNaLOG.append("\nIntervallo selezionato: "+inizio.toString()+"-"+fine.toString());
639 						boolean condizione=d.compareTo(inizio)>=0&&d.compareTo(fine)<=0;
640 						if(condizione) {
641 							csNaLOG.append("\n >> File trovato:"+s+"\n");
642 							csNaLOG.setSelectionStart(csNaLOG.getText().length());
643 							File local=new File("Files_FTP/"+s);
644 							// se file esiste non lo scrivo
645 							if (local.exists()) {
646 								csNaLOG.append("\nFile esistente in /Files_FTP, download non necessario!\n");
647 								ConsoleFTP.append(s+"\n>> file esistente in Files_FTP\n\n");
648 								csNaLOG.setSelectionStart(csNaLOG.getText().length());
649 								ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
650 							//altrimenti, se tutto va a buon fine avviso del corretto salvataggio
651 							}else if(dumper.saveLocalFile(FTPdir, s, "Files_FTP/"+s)) {
652 								csNaLOG.append("\n    - Files_FTP/"+s+" -> Salvato in locale. [Ora puoi esportare merge NOfilter e usare la scansione approfondita nel filtro]\n");
653 								ConsoleFTP.append(s+"\n>> File salvato\n\n");
654 								csNaLOG.setSelectionStart(csNaLOG.getText().length());
655 								ConsoleFTP.setSelectionStart(csNaLOG.getText().length());
656 							}
657 						}
658 						
659 					//se file splittato							
660 					}else if(type.equals("Port")){
661 						tokenizer.nextToken(); //porta del file splittato
662 						tokenizer.nextToken();// IP
663 						String fileDate="";
664 						// ricavo la data del dump e cancello l'estensione .cap
665 						fileDate=tokenizer.nextToken();
666 						//csNaLOG.append(fileDate);
667 						fileDate=fileDate.substring(0,(fileDate.length()-4));
668 						//csNaLOG.append("->"+fileDate);
669 						Date d=new Date();
670 						try {
671 							d = df.parse (fileDate);
672 						}catch(Exception e) {
673 							csNaLOG.append("\nErrore nella lettura dell'intervallo selezionato! :( \n");
674 						}						
675 						//csNaLOG.append("\nIntervallo selezionato: "+inizio.toString()+"-"+fine.toString());
676 						boolean condizione=d.compareTo(inizio)>=0&&d.compareTo(fine)<=0;
677 						//int userFilter=0;	
678 						//try {
679 						//	userFilter=((Integer)portFilter.getValue());
680 						//}catch(Exception e) {}
681 						if(condizione) {
682 							csNaLOG.append("\n >> File trovato:"+s+"\n");
683 							File local=new File("Files_FTP/"+s);
684 							// se file esiste non lo scrivo
685 							if (local.exists()) {
686 								csNaLOG.append("\nFile esistente in /Files_FTP, download non necessario!\n");
687 								ConsoleFTP.append(s+"\n>> file esistente in Files_FTP\n\n");
688 								csNaLOG.setSelectionStart(csNaLOG.getText().length());
689 								ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
690 							}else if(dumper.saveLocalFile(FTPdir, s, "Files_FTP/"+s)) {
691 								csNaLOG.append("\n    - Files_FTP/"+s+" -> Salvato in locale.\n");
692 								ConsoleFTP.append(s+"\n>> File salvato\n\n");
693 								csNaLOG.setSelectionStart(csNaLOG.getText().length());
694 								ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
695 							}
696 						}
697 											
698 					}
699 				}
700 				JOptionPane.showMessageDialog(frmCsnaBy, "Download terminato! File scaricati in /Files_FTP");
701 				csNaLOG.append("\n\n>> FINE, DMAD pronto:");
702 				ConsoleFTP.append("\n\n>> TERMINATO!");
703 				csNaLOG.setSelectionStart(csNaLOG.getText().length());
704 				ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
705 				DownloadDump.setEnabled(true);
706 				    }
707 				}).start();	
708 				
709 			}
710 		});
711 		
712 		DownloadDump.setBackground(new Color(240, 255, 255));
713 		DownloadDump.setFont(new Font("SansSerif", Font.BOLD, 17));
714 		frmCsnaBy.getContentPane().add(DownloadDump);
715 		
716 		JLabel ftponoff = new JLabel("Modalit\u00E0 ftps attiva");
717 		ftponoff.setBounds(1012, 281, 243, 32);
718 		ftponoff.setForeground(new Color(240, 255, 255));
719 		ftponoff.setFont(new Font("Tahoma", Font.BOLD, 18));
720 		ftponoff.setHorizontalAlignment(SwingConstants.CENTER);
721 		frmCsnaBy.getContentPane().add(ftponoff);
722 		
723 		JLabel msg = new JLabel("Cartella sorgente: \\Files_FTP");
724 		msg.setHorizontalAlignment(SwingConstants.CENTER);
725 		msg.setBounds(705, 274, 303, 47);
726 		msg.setFont(new Font("Tahoma", Font.BOLD, 18));
727 		frmCsnaBy.getContentPane().add(msg);			
728 		
729 		JCheckBox ftpON_OFF = new JCheckBox("(ON)");
730 		ftpON_OFF.setForeground(SystemColor.activeCaptionText);
731 		ftpON_OFF.setBounds(558, 184, 77, 38);
732 		ftpON_OFF.setFont(new Font("Tahoma", Font.BOLD, 16));
733 		ftpON_OFF.addActionListener(new ActionListener() {
734 			public void actionPerformed(ActionEvent arg0) {
735 				if(ftpON_OFF.isSelected()) { //accendi
736 					ConsoleFTP.append("\n ### Modulo ftps attivato ###\n");
737 					ftpON_OFF.setText("(ON)");
738 					lblFtpsLog.setForeground(Color.black);
739 					USER.setEnabled(true);
740 					PORTFTP.setEnabled(true);
741 					HOST.setEnabled(true);
742 					KEY.setEnabled(true);
743 					lblFtpsLog.setText("MODULO FTPS");
744 					DIR.setEnabled(true);
745 					Check.setEnabled(true);
746 					DownloadDump.setEnabled(true);
747 					ftponoff.setForeground(new Color(240, 255, 255));
748 					ftponoff.setText("Modalit ftps attiva");
749 					msg.setText("Cartella sorgente: \\Files_FTP");
750 										
751 				}else { //spegni
752 					ConsoleFTP.append("\n ### Modulo ftps disattivato ###\n");
753 					lblFtpsLog.setForeground(Color.gray);
754 					ftpON_OFF.setText("(OFF)");
755 					USER.setEnabled(false);
756 					lblFtpsLog.setText("MODULO FTPS");
757 					PORTFTP.setEnabled(false);
758 					HOST.setEnabled(false);
759 					KEY.setEnabled(false);
760 					DIR.setEnabled(false);
761 					Check.setEnabled(false);
762 					DownloadDump.setEnabled(false);
763 					ftponoff.setForeground(Color.blue);
764 					ftponoff.setText("Modalit ftps disattivata");
765 					msg.setText("Cartella sorgente: \\Files_Utente");
766 					
767 				}
768 			}
769 		});
770 		ftpON_OFF.setSelected(true);
771 		ftpON_OFF.setBackground(SystemColor.activeCaption);
772 		frmCsnaBy.getContentPane().add(ftpON_OFF);
773 		
774 		
775 		JButton btnFiltracartellaFtp = new JButton("FILTRA E UNISCI");
776 		btnFiltracartellaFtp.addActionListener(new ActionListener() {
777 			public void actionPerformed(ActionEvent arg0) {
778 				String sourcefolder;
779 				Vector <PcapPacket> packetBlacklist = new Vector<PcapPacket>(); 
780 				
781 				//se modulo ftp attivo uso files_FTP
782 				if(ftpON_OFF.isSelected()) {
783 					sourcefolder="Files_FTP";
784 					csNaLOG.append("\n\n>> Lettura cartella Files_Utente: \n\n");
785 				}else {//altrimenti uso i file caricati dall'utente
786 					sourcefolder="Files_Utente";
787 					csNaLOG.append("\n\n>> Lettura cartella Files_FTP: \n\n");
788 				}
789 				File cartellaSrc=new File(sourcefolder);
790 				String []filesSorgenti=cartellaSrc.list();
791 				for(String s:filesSorgenti) {
792 					csNaLOG.append(" - "+s+"\n");
793 				}
794 				if(filesSorgenti.length==0) {
795 					csNaLOG.append(" >> Nessun file nella cartella!\n");
796 					csNaLOG.append("\n\n ################### EXPORT TERMINATO. ###################\n\n");
797 					ConsoleFTP.append("\n>> EXPORT TERMINATO\n");
798 					csNaLOG.setSelectionStart(csNaLOG.getText().length());
799 					ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
800 				}
801 				btnFiltracartellaFtp.setEnabled(false);
802 				new Thread(new Runnable() {
803 				    public void run() {
804 				        //apro un thread per non bloccare il messaggio iniziale
805 				    	int PORTAscan=0;
806 						
807 						try {
808 							PORTAscan=((Integer)portFilter.getValue());
809 						}catch(Exception e) {btnFiltracartellaFtp.setEnabled(true);}
810 				    	boolean nessunFile=true;
811 				    	String exportName2="Export/Export_Filtered_"+ExportUserPath.getText()+".cap";
812 		        String exportName="Export/Export_Pt_"+PORTAscan+"_"+ExportUserPath.getText()+".cap";
813 		        exportMSG.setText("Salva come: \\Export\\Export_Pt_"+PORTAscan);
814 		        boolean firstappend=false;//usato per evitare l'append del global header la prima volta
815                 CaptureCycle cicloSplit;
816 				for (String s:filesSorgenti) {
817 					
818 					StringTokenizer tokenizer=new StringTokenizer(s, "-");
819 					String type=tokenizer.nextToken();
820 					//inizializzo variabili per il confronto della data del file con 
821 					//l'intervallo del filtro
822 					DateFormat df = new SimpleDateFormat ("yyyy_MM_dd.HH_mm");
823 					df.setLenient (false);
824 					Date inizio=(Date)Data_INIZIO.getValue();
825 					df.format(inizio);
826 					Date fine=(Date)Data_FINE.getValue();
827 					df.format(fine);
828 					StringBuilder errbuf = new StringBuilder(); 
829 					
830 					// Ora posso  distinguere se file filtrato per porta o non filtrato
831 					if(type.equals("NOfilter")&&(DEEP_SCAN_FLAG.isSelected()||!PORT_YN.isSelected())) {
832 						String IP=tokenizer.nextToken();
833 						String fileDate="";
834 						// ricavo la data del dump e cancello l'estensione .cap
835 						fileDate=tokenizer.nextToken();
836 						//csNaLOG.append(fileDate);
837 						fileDate=fileDate.substring(0,(fileDate.length()-4));
838 						//csNaLOG.append("->"+fileDate);
839 						Date d=new Date();
840 						try {
841 							d = df.parse (fileDate);
842 						}catch(Exception e) {
843 							btnFiltracartellaFtp.setEnabled(true);
844 							csNaLOG.append("\n\nErrore nella lettura dell'intervallo selezionato! :( \n");
845 							ConsoleFTP.append("\n>> Errore lettura intervallo :( \n");
846 							csNaLOG.setSelectionStart(csNaLOG.getText().length());
847 							ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
848 						}						
849 						//csNaLOG.append("\nIntervallo selezionato: "+inizio.toString()+"-"+fine.toString());
850 						boolean condizione=d.compareTo(inizio)>=0&&d.compareTo(fine)<=0;
851 						if(condizione) {
852 							
853 							cicloSplit=new CaptureCycle(errbuf, sourcefolder, "Temp", IP, FLOW_CONTR_FLAG.isSelected(), EXPR_FLAG.isSelected(), EXPR_FILTER.getText());
854 								//csNaLOG.append("\n\n"+cicloSplit.getOUTPUT()+"\n\n");
855 							if(PORT_YN.isSelected()) {
856 								String splitResult=cicloSplit.Split(s, PORTAscan, packetBlacklist);
857 								CapMerger.MergeToOUT(splitResult, exportName, firstappend);
858 							}
859 							else {
860 								
861 								String splitResult=cicloSplit.Filter(s, packetBlacklist);
862 								CapMerger.MergeToOUT(splitResult, exportName2, firstappend);
863 								
864 							}
865 								
866 							nessunFile=false;
867 							csNaLOG.append("\n>> Il file: "+s+" soddisfa i requisiti del filtro :D\n\n>> aggiunto a "+exportName+" :)\n");
868 							ConsoleFTP.append("\n>> file salvato");
869 							csNaLOG.setSelectionStart(csNaLOG.getText().length());
870 							ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
871 							if(firstappend==false) {
872 								firstappend=true;
873 							}
874 						}
875 						if(!condizione) {
876 							csNaLOG.append("\nIl file: "+s+" non soddisfa i requisiti del filtro :(\n");
877 						}
878 					}//end if(equals("NOfilter"))
879 					//l'else riguarda il caso file splittato per porta(senza deep scan attivo)
880 					//per evitare pacchetti ripetuti due volte - servirebbe un controllo pi
881 					//intelligente sull'esistenza del corrispettivo dump filtrato/nonfiltrato
882 					else if(type.equals("Port")&&!DEEP_SCAN_FLAG.isSelected()&&PORT_YN.isSelected()){
883 						String port=tokenizer.nextToken(); //porta del file splittato
884 						csNaLOG.append("\n -> "+s+": rilevato DUMP splittato sulla porta: "+port);
885 						String IP=tokenizer.nextToken();// IP
886 						String fileDate="";
887 						// ricavo la data del dump e cancello l'estensione .cap
888 						fileDate=tokenizer.nextToken();
889 						//csNaLOG.append(fileDate);
890 						fileDate=fileDate.substring(0,(fileDate.length()-4));
891 						//csNaLOG.append("->"+fileDate);
892 						Date d=new Date();
893 						try {
894 							d = df.parse (fileDate);
895 						}catch(Exception e) {
896 							btnFiltracartellaFtp.setEnabled(true);
897 							csNaLOG.append("\nErrore nella lettura dell'intervallo selezionato! :( \n");
898 							ConsoleFTP.append("\n>> Errore lettura intervallo :(\n");
899 							csNaLOG.setSelectionStart(csNaLOG.getText().length());
900 							ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
901 						}						
902 						//csNaLOG.append("\nIntervallo selezionato: "+inizio.toString()+"-"+fine.toString());
903 						boolean condizione=d.compareTo(inizio)>=0&&d.compareTo(fine)<=0;
904 						int userFilter=0;	
905 						try {
906 							userFilter=((Integer)portFilter.getValue());
907 						}catch(Exception e) {btnFiltracartellaFtp.setEnabled(true);}
908 						if(condizione&&userFilter==Integer.parseInt(port)) {
909 							
910 							
911 							cicloSplit=new CaptureCycle(errbuf, sourcefolder, "Temp", IP, FLOW_CONTR_FLAG.isSelected(), EXPR_FLAG.isSelected(), EXPR_FILTER.getText());
912 							String splitResult=cicloSplit.Split(s, PORTAscan, packetBlacklist);
913 							CapMerger.MergeToOUT(splitResult, exportName, firstappend);
914 							nessunFile=false;
915 							csNaLOG.append("\n>> Il file soddisfa i requisiti del filtro! :) \n\n>> aggiunto a "+exportName+" :)\n");
916 							ConsoleFTP.append("\n>> file salvato");
917 							csNaLOG.setSelectionStart(csNaLOG.getText().length());
918 							ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
919 							if(firstappend==false) {
920 								firstappend=true;
921 							}
922 														
923 						}
924 											
925 					}
926 				}
927 				//try {
928 				//	Files.write(Paths.get("./log.txt"), "Log:\n\n".getBytes());
929 				//}catch (Exception e) {
930 				//}
931 				csNaLOG.append("\n\n    ############# Merge dei file filtrati completato ##############\n\n      ############# Inizio analisi Export #############\n");
932 				ConsoleFTP.append("\n\n>> Fase di export terminata\n>> Inizio visualizzazione");
933 				csNaLOG.setSelectionStart(csNaLOG.getText().length());
934 				ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
935 				//ora visualizzo il file creato
936 				if(nessunFile) { // se nessun file corrisponde al filtro
937 					csNaLOG.append("\n\n>> Nessun file corrispondente ai parametri del filtro :(");
938 					ConsoleFTP.append("\n>> Nessun file corrisponde al filtro");
939 					btnFiltracartellaFtp.setEnabled(true);
940 					csNaLOG.setSelectionStart(csNaLOG.getText().length());
941 					ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
942 				}
943 				else { // se invece sono state trovate corrispondenze
944 					StringBuilder buff=new StringBuilder();
945 					if(!PORT_YN.isSelected()) {
946 						btnFiltracartellaFtp.setEnabled(true);
947 					 	JOptionPane.showMessageDialog(frmCsnaBy, (new File(exportName2)).getName()+": Completato - "+ (new File(exportName2)).length()+" Byte di dati");
948 						return;
949 					}
950 					final Pcap reader = Pcap.openOffline(exportName, buff);
951 					if (reader == null) {
952 						csNaLOG.append("\n>> Errore nella lettura dell'Export creato :(\n");
953 						ConsoleFTP.append("\n>> Errore lettura Export\n");
954 					}
955 					
956 					    	reader.loop(-1, new JPacketHandler<StringBuilder>() {
957 					            //inizializzo il tipo dei pacchetti di riferimento che user per 
958 								//riconoscere se salvare il pacchetto in nextpacket()
959 								final Tcp tcp = new Tcp();
960 					           	final Udp udp = new Udp();
961 					           	final Ip4 ip = new Ip4();
962 								int i=0;
963 								public void nextPacket(JPacket packet, StringBuilder errbuf) 
964 								{
965 									i++;
966 									if(packet.hasHeader(tcp)&&packet.hasHeader(ip)) {
967 										packet.getHeader(tcp);
968 										packet.getHeader(ip);
969 										//try {
970 										//	Files.write(Paths.get("./log.txt"), tcp.toString().getBytes(),StandardOpenOption.APPEND);
971 										//}catch (Exception e) {
972 										//}
973 										ConsoleFTP.append("\n-> Pacchetto(TCP) numero: #"+ i);
974 										csNaLOG.append("\n\n-> (TCP)Pacchetto numero: #"+ i);
975 										csNaLOG.append(" - tcp.dst_port="+ tcp.destination());
976 										csNaLOG.append(" - tcp.src_port="+ tcp.source());
977 										csNaLOG.append(" - ip.dst="+FormatUtils.ip(ip.destination()));
978 										csNaLOG.append(" - ip.src="+FormatUtils.ip(ip.source()));
979 										csNaLOG.append(" - tcp.ACK="+ tcp.ack());
980 										csNaLOG.append(" - tcp.SYN="+ tcp.flags_SYN());
981 										csNaLOG.append(" - tcp.FIN="+ tcp.flags_FIN());
982 										csNaLOG.append(" - TCP Payload (N of bytes)="+ tcp.getPayloadLength());
983 										
984 										
985 										//String payload=new String(tcp.getPayload());
986 										//csNaLOG.append("\n - tcp.payload="+ payload);
987 										
988 									}else if(packet.hasHeader(udp)) {
989 										packet.getHeader(udp);
990 										packet.getHeader(ip);
991 										ConsoleFTP.append("\n-> Pacchetto(UDP) numero: #"+ i);
992 										csNaLOG.append("\n\n-> (UDP)Pacchetto numero: #"+ i);
993 										csNaLOG.append(" - udp.dst_port="+ udp.destination());
994 										csNaLOG.append(" - udp.src_port="+ udp.source());
995 										csNaLOG.append(" - ip.dst="+FormatUtils.ip(ip.destination()));
996 										csNaLOG.append(" - ip.src="+FormatUtils.ip(ip.source()));
997 										csNaLOG.append(" - UDP Payload (N of bytes)="+ udp.getPayloadLength());
998 										//String payload=new String(udp.getPayload());
999 										//csNaLOG.append("\n - udp.payload="+ payload);	
1000									}
1001									csNaLOG.setSelectionStart(csNaLOG.getText().length());
1002									ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1003								}//end nextpacket()
1004							}, buff);//end loop scansione file
1005							reader.close(); //chiusura pcap 
1006							if(firstappend) {
1007				              	File export=new File(exportName);
1008				               	if (export.length()<1024) {//byte
1009				               	  	JOptionPane.showMessageDialog(frmCsnaBy, "Completato, il file "+export.getName()+" ha "+export.length()+" Byte di dati");
1010							   	}else if(export.length()>=1024 && export.length()<(1024*1024)) {//kbyte
1011				               	  	JOptionPane.showMessageDialog(frmCsnaBy, "Completato, il file "+export.getName()+" ha "+export.length()/1024+" kByte di dati");             
1012				               	}else {//MByte
1013				               	  	JOptionPane.showMessageDialog(frmCsnaBy, "Completato, il file "+export.getName()+" ha "+export.length()/(1024*1024)+" MByte di dati");
1014					        	}
1015				            }
1016							csNaLOG.append("\n\n>> ################### COMPLETATO. ###################\n\n");
1017							ConsoleFTP.append("\n\n>> FILTRA! terminato correttamente\n");
1018							csNaLOG.setSelectionStart(csNaLOG.getText().length());
1019							ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1020							btnFiltracartellaFtp.setEnabled(true);
1021					  				
1022				}
1023				    }
1024				}).start();
1025				
1026				
1027			}
1028		});
1029		btnFiltracartellaFtp.setBounds(422, 272, 268, 49);
1030		btnFiltracartellaFtp.setFont(new Font("SansSerif", Font.BOLD, 20));
1031		btnFiltracartellaFtp.setBackground(new Color(240, 248, 255));
1032		frmCsnaBy.getContentPane().add(btnFiltracartellaFtp);
1033		
1034		
1035		
1036		
1037		JLabel lblImpostazioniAvanzateDel = new JLabel("Opzioni filtro");
1038		lblImpostazioniAvanzateDel.setForeground(new Color(47, 79, 79));
1039		lblImpostazioniAvanzateDel.setBounds(675, 74, 572, 28);
1040		lblImpostazioniAvanzateDel.setHorizontalAlignment(SwingConstants.CENTER);
1041		lblImpostazioniAvanzateDel.setFont(new Font("Tahoma", Font.BOLD, 20));
1042		lblImpostazioniAvanzateDel.setAlignmentX(0.5f);
1043		frmCsnaBy.getContentPane().add(lblImpostazioniAvanzateDel);
1044		
1045		Box horizontalBox_2 = Box.createHorizontalBox();
1046		horizontalBox_2.setBounds(665, 73, 596, 32);
1047		horizontalBox_2.setBorder(new MatteBorder(3, 3, 3, 3, (Color) new Color(0, 0, 0)));
1048		horizontalBox_2.setBackground(SystemColor.inactiveCaption);
1049		frmCsnaBy.getContentPane().add(horizontalBox_2);
1050		
1051		JButton MergeExports = new JButton("Esporta merge non filtrato");
1052		MergeExports.setBounds(422, 234, 268, 33);
1053		MergeExports.addActionListener(new ActionListener() {
1054			public void actionPerformed(ActionEvent arg0) {
1055				String sourcefolder;
1056				//se modulo ftp attivo uso files_FTP
1057				if(ftpON_OFF.isSelected()) {
1058					sourcefolder="Files_FTP";
1059					csNaLOG.append("\n\n>> Lettura cartella Files_Utente: \n");
1060				}else {//altrimenti uso i file caricati dall'utente
1061					sourcefolder="Files_Utente";
1062					csNaLOG.append("\n\n>> Lettura cartella Files_FTP: \n");
1063				}
1064				File cartellaSrc=new File(sourcefolder);
1065				String []filesSorgenti=cartellaSrc.list();
1066				for(String s:filesSorgenti) {
1067					csNaLOG.append("\n - "+s);
1068				}
1069				if(filesSorgenti.length==0) {
1070					csNaLOG.append(" >> Nessun file nella cartella!\n");
1071					csNaLOG.append("\n\n>> ################### EXPORT TERMINATO. ###################\n\n");
1072					ConsoleFTP.append("\n\n>> EXPORT TERMINATO\n");
1073					csNaLOG.setSelectionStart(csNaLOG.getText().length());
1074					ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1075				}
1076				
1077				//String date = new SimpleDateFormat("dd_MM_yyyy_HH.mm.ss").format( new Date());
1078				String exportName="Export/Export_NOfilter_"+ExportUserPath.getText()+".cap";
1079				exportMSG.setText("Salva come: \\Export\\Export_NOfilter_");
1080				boolean firstappend=false;//usato per evitare l'append del global header la prima volta
1081                for (String s:filesSorgenti) {
1082					
1083					StringTokenizer tokenizer=new StringTokenizer(s, "-");
1084					String type=tokenizer.nextToken();
1085					//inizializzo variabili per il confronto della data del file con 
1086					//l'intervallo del filtro
1087					DateFormat df = new SimpleDateFormat ("yyyy_MM_dd.HH_mm");
1088					df.setLenient (false);
1089					Date inizio=(Date)Data_INIZIO.getValue();
1090					df.format(inizio);
1091					Date fine=(Date)Data_FINE.getValue();
1092					df.format(fine);
1093					// Ora posso  distinguere se file filtrato per porta o non filtrato
1094					if(type.equals("NOfilter")) {
1095						tokenizer.nextToken();
1096						String fileDate="";
1097						// ricavo la data del dump e cancello l'estensione .cap
1098						fileDate=tokenizer.nextToken();
1099						//csNaLOG.append(fileDate);
1100						fileDate=fileDate.substring(0,(fileDate.length()-4));
1101						//csNaLOG.append("->"+fileDate);
1102						Date d=new Date();
1103						try {
1104							d = df.parse (fileDate);
1105						}catch(Exception e) {
1106							csNaLOG.append("\nErrore nella lettura dell'intervallo selezionato! :( \n");
1107							csNaLOG.setSelectionStart(csNaLOG.getText().length());
1108							ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1109						}						
1110						//csNaLOG.append("\nIntervallo selezionato: "+inizio.toString()+"-"+fine.toString());
1111						boolean condizione=d.compareTo(inizio)>=0&&d.compareTo(fine)<=0;
1112						if(condizione) {
1113							csNaLOG.append("\nIl file: "+s+" soddisfa i requisiti del filtro :D\n\n>> aggiunto a "+exportName+" :)\n");
1114							CapMerger.MergeToOUT((sourcefolder+"/"+s), exportName, firstappend);
1115							if(firstappend==false) {
1116								firstappend=true;
1117							}
1118						}
1119						if(!condizione) {
1120							csNaLOG.append("\nIl file: "+s+" non soddisfa i requisiti del filtro :(\n");
1121							csNaLOG.setSelectionStart(csNaLOG.getText().length());
1122						}
1123					}}
1124                if(firstappend) {
1125	              	File export=new File(exportName);
1126	               	if (export.length()<1024) {//byte
1127	               	  	JOptionPane.showMessageDialog(frmCsnaBy, "Completato, il file "+export.getName()+" ha "+export.length()+" Byte di dati");
1128				   	}else if(export.length()>=1024 && export.length()<(1024*1024)) {//kbyte
1129	               	  	JOptionPane.showMessageDialog(frmCsnaBy, "Completato, il file "+export.getName()+" ha "+export.length()/1024+" kByte di dati");             
1130	               	}else {//MByte
1131	               	  	JOptionPane.showMessageDialog(frmCsnaBy, "Completato, il file "+export.getName()+" ha "+export.length()/(1024*1024)+" MByte di dati");
1132		        	}
1133	            }
1134                csNaLOG.append("\n\n>> ################### EXPORT TERMINATO. ###################\n\n");
1135				ConsoleFTP.append("\n\n>> EXPORT TERMINATO\n");
1136				csNaLOG.setSelectionStart(csNaLOG.getText().length());
1137				ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1138			}
1139		});
1140		MergeExports.setBackground(new Color(240, 248, 255));
1141		MergeExports.setFont(new Font("SansSerif", Font.BOLD, 17));
1142		frmCsnaBy.getContentPane().add(MergeExports);
1143		
1144		JLabel lblcap = new JLabel(".cap");
1145		lblcap.setFont(new Font("Tahoma", Font.PLAIN, 18));
1146		lblcap.setBounds(1233, 236, 39, 34);
1147		frmCsnaBy.getContentPane().add(lblcap);
1148		
1149		Box horizontalBox_3 = Box.createHorizontalBox();
1150		horizontalBox_3.setBorder(new LineBorder(Color.DARK_GRAY, 2, true));
1151		horizontalBox_3.setForeground(Color.DARK_GRAY);
1152		horizontalBox_3.setBounds(151, 281, 256, 40);
1153		frmCsnaBy.getContentPane().add(horizontalBox_3);
1154		
1155		JButton btnEliminaDumpLocali = new JButton("Elimina File");
1156		btnEliminaDumpLocali.setFont(new Font("Tahoma", Font.BOLD, 17));
1157		btnEliminaDumpLocali.addActionListener(new ActionListener() {
1158			public void actionPerformed(ActionEvent arg0) {
1159				
1160				File sourcefolder1=new File("Files_FTP");
1161				File sourcefolder2=new File("Files_Utente");
1162				File sourcefolder3=new File("Export");
1163				
1164				if(FTP_DELETE_FLAG.isSelected()||EXPORT_DELETE_FLAG.isSelected()||USER_DELETE_FLAG.isSelected()) {
1165		    		
1166					int selectedOption = JOptionPane.showConfirmDialog(frmCsnaBy, 
1167                              "Vuoi davvero eliminare i file nelle cartelle selezionate? L'operazione non  reversibile.", 
1168                              "Elimina file nelle cartelle locali", 
1169                              JOptionPane.YES_NO_OPTION); 
1170					
1171					if (selectedOption == JOptionPane.YES_OPTION) {
1172					    csNaLOG.append("\n >> Avvio eliminazione files in corso...\n");
1173					    ConsoleFTP.append("\n >> CONFERMATO - AVVIO SCANSIONE FILE");
1174					    new Thread(new Runnable() {
1175	    					
1176							public void run() {
1177													
1178						    	try {
1179						    		btnEliminaDumpLocali.setEnabled(false);
1180						    		if(FTP_DELETE_FLAG.isSelected()) {
1181						    			File []deletelist1=sourcefolder1.listFiles();
1182						    			if(deletelist1.length==0) {
1183											csNaLOG.append("\n >> Nessun file nella cartella "+sourcefolder1.getName()+"!\n");
1184											ConsoleFTP.append("\n >> Nessun file in "+sourcefolder1.getName()+"!\n");
1185											csNaLOG.setSelectionStart(csNaLOG.getText().length());
1186											ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1187										}else {
1188											csNaLOG.append("\n ###### Cartella "+sourcefolder1.getName()+" ######\n");
1189											for(File f:deletelist1) {
1190												if(!f.delete()) {
1191													ConsoleFTP.append("\n >> Eliminazione di:\n"+f.getName()+"\n >> Non riuscita." );
1192													csNaLOG.append("\n >> Eliminazione di: "+f.getName()+" non riuscita." );
1193												}    
1194												else {
1195													ConsoleFTP.append("\n -> "+f.getName()+"\n >> ELIMINATO" );
1196													csNaLOG.append("\n -> "+f.getName()+" >> ELIMINATO." );
1197												}
1198												ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1199												csNaLOG.setSelectionStart(csNaLOG.getText().length());
1200											}
1201										}
1202						    		}
1203						    		if(USER_DELETE_FLAG.isSelected()) {
1204						    			File []deletelist2=sourcefolder2.listFiles();
1205						    			if(deletelist2.length==0) {
1206											csNaLOG.append("\n >> Nessun file nella cartella "+sourcefolder2.getName()+"!\n");
1207											ConsoleFTP.append("\n >> Nessun file in "+sourcefolder2.getName()+"!\n");
1208											csNaLOG.setSelectionStart(csNaLOG.getText().length());
1209											ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1210										}else {
1211											csNaLOG.append("\n ###### Cartella "+sourcefolder2.getName()+" ######\n");
1212											for(File f:deletelist2) {
1213												if(!f.delete()) {
1214													ConsoleFTP.append("\n >> Eliminazione di:\n"+f.getName()+"\n >> Non riuscita." );
1215													csNaLOG.append("\n >> Eliminazione di: "+f.getName()+" non riuscita." );
1216												}    
1217												else {
1218													ConsoleFTP.append("\n -> "+f.getName()+"\n >> ELIMINATO" );
1219													csNaLOG.append("\n -> "+f.getName()+" >> ELIMINATO." );
1220												}
1221												ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1222												csNaLOG.setSelectionStart(csNaLOG.getText().length());
1223											}
1224										}
1225						    		}
1226						    		if(EXPORT_DELETE_FLAG.isSelected()) {
1227						    			File []deletelist3=sourcefolder3.listFiles();
1228						    			if(deletelist3.length==0) {
1229											csNaLOG.append("\n >> Nessun file nella cartella "+sourcefolder3.getName()+"!\n");
1230											ConsoleFTP.append("\n >> Nessun file in "+sourcefolder3.getName()+"!\n");
1231											csNaLOG.setSelectionStart(csNaLOG.getText().length());
1232											ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1233										}else {
1234											csNaLOG.append("\n ###### Cartella "+sourcefolder3.getName()+" ######\n");
1235											for(File f:deletelist3) {
1236												if(!f.delete()) {
1237													ConsoleFTP.append("\n >> Eliminazione di:\n"+f.getName()+"\n >> Non riuscita." );
1238													csNaLOG.append("\n >> Eliminazione di: "+f.getName()+" non riuscita." );
1239												}    
1240												else {
1241													ConsoleFTP.append("\n -> "+f.getName()+"\n >> ELIMINATO" );
1242													csNaLOG.append("\n -> "+f.getName()+" >> ELIMINATO." );
1243												}
1244												ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1245												csNaLOG.setSelectionStart(csNaLOG.getText().length());
1246											}
1247										}
1248						    		}
1249						    		btnEliminaDumpLocali.setEnabled(true);
1250						    		csNaLOG.append("\n >> Eliminazione files terminata.\n");
1251									ConsoleFTP.append("\n >> Elimina terminato\n");
1252									csNaLOG.setSelectionStart(csNaLOG.getText().length());
1253									ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1254						    		
1255						    	}catch(Exception e) {
1256						    		btnEliminaDumpLocali.setEnabled(true);
1257						    		csNaLOG.append("\n >> ERRORE NELL'ELIMINAZIONE DEI FILE!\n");
1258									ConsoleFTP.append("\n >>  ERRORE NELL'ELIMINAZIONE!\n");
1259									csNaLOG.setSelectionStart(csNaLOG.getText().length());
1260									ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1261						    	}//fine catch
1262						    }}).start();//fine thread
1263					    
1264					
1265					}else { // se l'utente annulla l'operazione
1266						csNaLOG.append("\n >> OPERAZIONE ANNULLATA DALL'UTENTE!\n");
1267						ConsoleFTP.append("\n >> ANNULLATA DALL'UTENTE\n\n >>");
1268						csNaLOG.setSelectionStart(csNaLOG.getText().length());
1269						ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1270			    	}
1271	    		}//FINE if almeno un check selezionato
1272				else {
1273					csNaLOG.append("\n >> Nessuna cartella selezionata\n");
1274					ConsoleFTP.append("\n >> Nessuna cartella selezionata\n\n >>");
1275					csNaLOG.setSelectionStart(csNaLOG.getText().length());
1276					ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1277				}
1278			}
1279		});
1280		btnEliminaDumpLocali.setBackground(new Color(255, 228, 181));
1281		btnEliminaDumpLocali.setBounds(991, 5, 270, 30);
1282		frmCsnaBy.getContentPane().add(btnEliminaDumpLocali);
1283		
1284		JButton btnVediFile = new JButton("Visualizza File");
1285		btnVediFile.addActionListener(new ActionListener() {
1286			public void actionPerformed(ActionEvent arg0) {
1287				
1288				File sourcefolder1=new File("Files_FTP");
1289				File sourcefolder2=new File("Files_Utente");
1290				File sourcefolder3=new File("Export");
1291				
1292				if(FTP_DELETE_FLAG.isSelected()||EXPORT_DELETE_FLAG.isSelected()||USER_DELETE_FLAG.isSelected()) {
1293		    		 new Thread(new Runnable() {
1294	    				public void run() {
1295					
1296	    					try {
1297						    		if(FTP_DELETE_FLAG.isSelected()) {
1298						    			File []list1=sourcefolder1.listFiles();
1299						    			ConsoleFTP.append("\n >> Directory: "+sourcefolder1.getName());
1300						    			csNaLOG.append("\n ################### CARTELLA: "+sourcefolder1.getName()+" #########################\n\n");
1301						    			if(list1.length==0) {
1302											csNaLOG.append("\n >> Nessun file nella cartella "+sourcefolder1.getName()+"!\n");
1303											ConsoleFTP.append("\n >> Nessun file in "+sourcefolder1.getName()+"!\n");
1304											csNaLOG.setSelectionStart(csNaLOG.getText().length());
1305											ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1306										}else {
1307											ConsoleFTP.append("\n >> Lettura directory: "+sourcefolder1.getName()+"\n");
1308											for(File f:list1) {
1309												if(f.isDirectory()) {													
1310													csNaLOG.append("\n >> Directory: "+f.getName());
1311												}    
1312												else if(f.isFile()) {
1313													String fname=f.getName();
1314													String extension=fname.substring(fname.length()-4,fname.length());
1315													if(!extension.equals(".cap")) {
1316														csNaLOG.append("\n -> File generico: "+f.getName());
1317													}else {
1318														csNaLOG.append("\n### File .cap, contiene pacchetti di rete: "+f.getName()+" ("+f.length()+" Byte)");
1319													}
1320													
1321												}
1322												ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1323												csNaLOG.setSelectionStart(csNaLOG.getText().length());
1324											}
1325										}
1326						    		}
1327						    		if(USER_DELETE_FLAG.isSelected()) {
1328						    			ConsoleFTP.append("\n >> Directory: "+sourcefolder2.getName()+"\n");
1329						    			csNaLOG.append("\n\n ################### CARTELLA: "+sourcefolder2.getName()+" #########################\n\n");
1330						    			File []list2=sourcefolder2.listFiles();
1331						    			if(list2.length==0) {
1332											csNaLOG.append("\n >> Nessun file nella cartella "+sourcefolder2.getName()+"!\n");
1333											ConsoleFTP.append("\n >> Nessun file in "+sourcefolder2.getName()+"!\n");
1334											csNaLOG.setSelectionStart(csNaLOG.getText().length());
1335											ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1336										}else {
1337											for(File f:list2) {
1338												if(f.isDirectory()) {													
1339													csNaLOG.append("\n >> Directory:"+f.getName());
1340												}    
1341												else if(f.isFile()) {
1342													String fname=f.getName();
1343													String extension=fname.substring(fname.length()-4,fname.length());
1344													if(!extension.equals(".cap")) {
1345														csNaLOG.append("\n -> File generico: "+f.getName());
1346													}else {
1347														csNaLOG.append("\n### File .cap, contiene pacchetti di rete: "+f.getName()+" ("+f.length()+" Byte)");
1348															}
1349												}
1350												ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1351												csNaLOG.setSelectionStart(csNaLOG.getText().length());
1352												
1353											}
1354										}
1355						    		}
1356						    		if(EXPORT_DELETE_FLAG.isSelected()) {
1357						    			ConsoleFTP.append("\n >> Directory: "+sourcefolder3.getName()+"!\n");
1358						    			csNaLOG.append("\n\n ################### CARTELLA: "+sourcefolder3.getName()+" #########################\n\n");
1359						    			File []list3=sourcefolder3.listFiles();
1360						    			if(list3.length==0) {
1361											csNaLOG.append("\n >> Nessun file nella cartella "+sourcefolder3.getName()+"!\n");
1362											ConsoleFTP.append("\n >> Nessun file in "+sourcefolder3.getName()+"!\n");
1363											csNaLOG.setSelectionStart(csNaLOG.getText().length());
1364											ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1365										}else {
1366											for(File f:list3) {
1367												if(f.isDirectory()) {													
1368													csNaLOG.append("\n >> Directory:"+f.getName());
1369												}    
1370												else if(f.isFile()) {
1371													String fname=f.getName();
1372													String extension=fname.substring(fname.length()-4,fname.length());
1373													if(!extension.equals(".cap")) {
1374														csNaLOG.append("\n -> File generico: "+f.getName());
1375													}else {
1376														csNaLOG.append("\n### File .cap, contiene pacchetti di rete: "+f.getName()+" ("+f.length()+" Byte)");
1377													}
1378												}
1379												ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1380												csNaLOG.setSelectionStart(csNaLOG.getText().length());
1381											}
1382										}
1383						    		}
1384						    		
1385						    		csNaLOG.append("\n >> TERMINATO.\n");
1386									ConsoleFTP.append("\n >> TERMINATO!\n");
1387									csNaLOG.setSelectionStart(csNaLOG.getText().length());
1388									ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1389						    		
1390						    	}catch(Exception e) {
1391						    		csNaLOG.append("\n >> ERRORE NELL'APERTURA DEI FILE!\n");
1392									ConsoleFTP.append("\n >>  ERRORE NELLA LETTURA!\n");
1393									csNaLOG.setSelectionStart(csNaLOG.getText().length());
1394									ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1395						    	}//fine catch
1396						    }}).start();//fine thread
1397					    
1398					
1399					}else {
1400						csNaLOG.append("\n\n >> TERMINATO (Nessuna directory selezionata)\n");
1401						ConsoleFTP.append("\n >> NESSUNA CARTELLA SELEZIONATA!\n");
1402						csNaLOG.setSelectionStart(csNaLOG.getText().length());
1403						ConsoleFTP.setSelectionStart(ConsoleFTP.getText().length());
1404					}
1405	    		}//FINE if almeno un check selezionato
1406					
1407		});
1408		btnVediFile.setFont(new Font("Tahoma", Font.BOLD, 17));
1409		btnVediFile.setBackground(new Color(240, 255, 240));
1410		btnVediFile.setBounds(991, 39, 270, 30);
1411		frmCsnaBy.getContentPane().add(btnVediFile);
1412			
1413		
1414	}
1415}
1416